#include <iostream>
#include <sstream>
#include <vector>
using namespace std;

ostream& operator <<( ostream& out, const vector<int>& obj ) {
   out << "[ ";
   for( auto i = obj.begin(); i != obj.end(); i++ ) 
      out << *i << " ";
   return out << "]";
}

class tree : protected vector< vector<int> > {
public:
   vector<int> killed;
   tree( vector<int>& data ) {
      unsigned n = data.size() + 1;
      for( unsigned i = 0; i < n; i++ ) push_back( vector<int>( 0 ) );
      for( unsigned i = 0; i < data.size(); i++ ) {
         (*this)[ data[ i ] ].push_back( i + 2 ); 
      }
   }
   ~tree( void ) { for( auto &x: *this ) x.clear(); }
   friend ostream& operator <<( ostream& out, const tree& obj ) {
      for( unsigned i = 1; i < obj.size(); i++ )
         cout << i << "\t: " << ( obj[ i ] ) << endl; 
      return out;
   }
   int reduce( int k, int level = 1 ) {
      if( 1 == level ) killed.clear();
      if( (*this)[ level ].empty() ) return 1; // терминальная вершина
      int sum = 1;
      for( auto x: (*this)[ level ] )          // обход вниз не терминала
         sum += reduce( k, x );
      if( sum < k ) return sum;
      killed.push_back( level );
      (*this)[ level ].clear();
      return 0;
   }
}; 

int main( int argc, char** argv ) {
   bool debug = argc > 1;
   string e;
   int K, N;
   getline( cin, e );
   istringstream( e ) >> K; 
   getline( cin, e );
   istringstream( e ) >> N; 
   vector<int> line;
   getline( cin, e );
   istringstream sst( e );
   int d;
   while( sst >> d )
      line.push_back( d );
   if( debug )
      cout << "ввод: " << K << " | " << N << " | " << line << endl;
   tree t( line );
   if( debug ) cout << t;
   t.reduce( K );
   cout << "удалённых узлов " << t.killed.size() << " : " << t.killed << endl;  
}


/*
Входной файл содержит три строки. В первой записано число K (1 ≤ K ≤ 10 000), 
во второй строке — число N (1 ≤ N ≤ 10 000), определяющее количество членов партии. 
Третья строка содержит набор из N—1 числа. В этой строке для каждого члена партии, кроме лидера, 
задается номер его непосредственного руководителя. Номер руководителя всегда меньше, чем номер подчиненного. 
При этом первое число задает номер руководителя второго члена партии, второе — третьего и так далее. 
Числа в строке разделяются одним пробелом.
*/


